/*
 * Licensed Materials - Property of IBM
 * 		5724-D15, 5724-I66
 * 
 * (C) Copyright IBM Corporation 2003, 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp. 
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */

package com.emerged.news;

import java.util.Vector;

/**
 * @author wendyb
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class NewsGenerator {

	private NewsArticle[] allArticles;

	private static NewsGenerator singleton = null;

	/**
	 * Constructor for NewsGenerator.
	 */
	protected NewsGenerator() {
		super();

		allArticles = new NewsArticle[18];

		/*
		 * Information Technology articles
		 */
		allArticles[0] = new NewsArticle(
				"IBM Creates World's Fastest Semiconductor Circuits", "html/IBMSemi.html",
				NewsCategory.IT);
		allArticles[1] = new NewsArticle(
				"IBM Introduces An Ultraportable ThinkPad Package That Goes On And On For Eight Hours",
				"html/IBMThinkpad.html", NewsCategory.IT);
		allArticles[2] = new NewsArticle(
				"General Motors Selects IBM UNIX Servers For Global Operations",
				"html/GMIBM.html", NewsCategory.IT);
		allArticles[3] = new NewsArticle(
				"Intel's dual-core processor improves", "html/IntelDualCore.html", NewsCategory.IT);
		allArticles[4] = new NewsArticle(
				"Microsoft hopes customers will spread advertising word", "html/MSFTCustomers.html",
				NewsCategory.IT);
		allArticles[5] = new NewsArticle("Google testing alternate searches",
				"html/Googlealternate.html", NewsCategory.IT);
		allArticles[6] = new NewsArticle(
				"Free online atlas of Canada launched", "html/FreeAtlas.html", NewsCategory.IT);

		/*
		 * Religion articles
		 */
		allArticles[7] = new NewsArticle(
				"IBM retirees gather to trade news and gossip", "html/IBMRetirees.html",
				NewsCategory.RELIGION);
		allArticles[8] = new NewsArticle("Where does your sermon come from?",
				"html/WhereSermon.html", NewsCategory.RELIGION);
		allArticles[9] = new NewsArticle("Internet churches on the rise", "html/InternetChurches.html",
				NewsCategory.RELIGION);
		allArticles[10] = new NewsArticle(
				"TV networks place faith in religion plots", "html/TVNetworks.html",
				NewsCategory.RELIGION);

		/*
		 * Entertainment articles
		 */
		allArticles[11] = new NewsArticle("Academy Awards Results Leaked", "html/AcademyAwards.html",
				NewsCategory.ENTERTAINMENT);
		allArticles[12] = new NewsArticle(
				"Microsoft aims at next generation television", "html/MSFTNextGen.html",
				NewsCategory.ENTERTAINMENT);
		allArticles[13] = new NewsArticle(
				"Microsoft Reveals More Xbox 2 Details", "html/MSFTXbox2.html",
				NewsCategory.ENTERTAINMENT);
		allArticles[14] = new NewsArticle(
				"Google Video Plans to Take Video Submissions", "html/GoogleVideo.html",
				NewsCategory.ENTERTAINMENT);

		/*
		 * Sports articles
		 */
		allArticles[15] = new NewsArticle(
				"IBM Canada Ltd. signs a six-year agreement as official partner of Air Canada Centre.",
				"html/IBMAirCanada.html", NewsCategory.SPORTS);
		allArticles[16] = new NewsArticle(
				"Canada hires new mountain bike coach", "html/CanadaCoach.html", NewsCategory.SPORTS);
		allArticles[17] = new NewsArticle(
				"Development plans threatened by Olympic security", "html/SecurityOlympics.html",
				NewsCategory.SPORTS);
	}

	public static NewsGenerator getInstance() {

		if (singleton == null) {
			singleton = new NewsGenerator();
		}

		return singleton;
	}

	public NewsArticle[] getNewsArticles(NewsCategory[] categories) {
		Vector v = new Vector();
		NewsArticle[] articles = null;
		NewsArticle article = null;
		
		
		for (int i = 0; i < allArticles.length; i++) {
			article = allArticles[i];

			for (int j = 0; j < categories.length; j++) {
				
				if ( (article.getCategory().getId() == categories[j].getId()) &&
					 (article.getCategory().getName().equals(categories[j].getName()))	
						) {
					v.add(article);
				}
			}
		}

		if (v.size() > 0) {
		   articles = (NewsArticle[]) v.toArray(new NewsArticle[0]);
		}
		return articles;
	}

}
