      *
      * Licensed Materials - Property of IBM
      * 5724-D15, 5724-I66
      * (C) Copyright IBM Corporation 200X, 2005. All
      * Rights Reserved. 
      * Note to U.S. Government Users Restricted Rights:
      * Use, duplication or disclosure restricted by GSA
      * ADP  Schedule Contract with IBM Corp. 
      * DISCLAIMER:
      * The following [enclosed] code is sample code
      * created by IBM Corporation. This sample code is not
      * part of any standard IBM productand is provided to
      * you solely for the purpose of assisting you in the
      * development of your applications. The code is
      * provided 'AS IS', without warranty of any kind.
      * IBM shall not be liable for any damages arising out
      * of your use of sample code, even if they have been
      * advised of the possibility of such damages.
      *
       identification division.
       program-id. NEWCUST.
       environment division.
       data division.

       WORKING-STORAGE SECTION.

       LINKAGE SECTION.
       01  DFHCOMMAREA.
           02  CUSTOMER.
               03  customerNumber     PIC X(10).
      * YYYY/MM/DD
               03  customerSince      PIC X(10).
               03  firstName          PIC A(20).
               03  lastName           PIC A(20).
               03  CUSTOMERADDRESS.
                   04  streetAddress      PIC X(50).
                   04  city               PIC A(20).
                   04  state              PIC A(20).
                   04  country            PIC A(20).
                   04  zipCode            PIC X(20).
               03  phoneNumber        PIC X(15).
               03  sin                PIC X(20).
               03  cashBalance        PIC S9(9)V99.
               03  maximumTransactionAmount
                                      PIC S9(9)V99.               
               03  returnCode         PIC 9(5).
               03  numberOfStockSymbols    PIC 9.
               03  quantityOfShares OCCURS 0 to 5 TIMES
           DEPENDING ON numberOfStockSymbols OF CUSTOMER PIC 9(5).
               03  stockSymbols OCCURS 0 to 5 TIMES
           DEPENDING ON numberOfStockSymbols OF CUSTOMER PIC X(5).
           02  OLDCUSTOMER.
               03  customerNumber     PIC X(10).
      * YYYY/MM/DD
               03  customerSince      PIC X(10).
               03  firstName          PIC A(20).
               03  lastName           PIC A(20).
               03  OLDCUSTOMERADDRESS.
                   04  streetAddress      PIC X(50).
                   04  city               PIC A(20).
                   04  state              PIC A(20).
                   04  country            PIC A(20).
                   04  zipCode            PIC X(20).
               03  phoneNumber        PIC X(15).
               03  sin                PIC X(20).
               03  cashBalance        PIC S9(9)V99.
               03  maximumTransactionAmount
                                      PIC S9(9)V99.               
               03  numberOfStockSymbols    PIC 9.
               03  quantityOfShares OCCURS 5 TIMES PIC 9(5).
               03  stockSymbols OCCURS 5 TIMES PIC X(5).


       PROCEDURE DIVISION.

       MAIN-PARA.

           PERFORM PROCESS-CUSTOMER.
           PERFORM LEAVE.


       PROCESS-CUSTOMER.

      * Pretend that the data was saved to persistent storage

           MOVE 0 TO returnCode.

       PROCESS-CUSTOMER-END.


       LEAVE.
           EXEC CICS RETURN.
           END-EXEC.
       LEAVE-END.
