/*
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 
package com.emerged.brokerage;


public class BrokerageBean {

	private BrokerageDatabaseBean dbBean = null;
	

	public BrokerageBean() {
		super();
		dbBean = new BrokerageDatabaseBean();
	}

	public Customer createCustomer(Customer inputCustomer) {
		return dbBean.createCustomer( inputCustomer );
	}
	
	public Customer updateCustomer(Customer inputCustomer) {
		return dbBean.updateCustomer( inputCustomer );
	}
	
	public Customer retrieveCustomer(Customer inputCustomer) {
		return dbBean.retrieveCustomer( inputCustomer );
	}

	public Customer deleteCustomer(Customer inputCustomer) {
		return dbBean.deleteCustomer( inputCustomer );
	}
	
	public SharesRequest buyShares(SharesRequest inputSharesRequest) {
		return dbBean.buyShares( inputSharesRequest );
	}

	public SharesRequest sellShares(SharesRequest inputSharesRequest) {
		return dbBean.sellShares( inputSharesRequest );
	}
	
	public CashBalanceChangeRequest deposit(CashBalanceChangeRequest inputCashBalanceChangeRequest) {
		return dbBean.deposit( inputCashBalanceChangeRequest );
	}

	public CashBalanceChangeRequest withdraw(CashBalanceChangeRequest inputCashBalanceChangeRequest) {
		return dbBean.withdraw( inputCashBalanceChangeRequest );
	}
	
    public WebLoginInfo validateWebUser(WebLoginInfo req) {
    	return dbBean.validateWebUser( req );
    }
}
