/*
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 
package com.emerged.brokerage;

import java.sql.*;

import com.emerged.brokerage.BrokerageDatabaseConstants;

public class CreateBrokerageDatabase {
	
    private static com.ibm.db2j.jdbc.DB2jDataSource ds = null;
    private static Connection c = null;
    private static String sFileSeparator = java.io.File.separator;
    
	public static void main(String[] args) {
		
		
  try {

  	  	
     startUp();

     System.out.println("Creating and connecting to the " + BrokerageDatabaseConstants.sDatabaseName + " database ...");    
     Connection conn = getConnection();
     System.out.println(" ");          

     Statement stmt = conn.createStatement(); 
  
     String[] dropTable = new String[]{"drop table customers","drop table stocks"};
     
     System.out.println("Dropping existing tables...");
     for(int i=0;i<dropTable.length;i++){
     	
	     try {
	        //drop table
	        stmt.execute( dropTable[i] ); 
	        System.out.println(dropTable[i]);
	     }//try
	     catch(Exception e) {
           //if table doesn't exist, no sense reporting that drop failed.
	     }
     }//for

     //create the tables
     
     
     System.out.println("Creating CUSTOMERS table...");                 
     stmt.execute( "create table customers (customernumber varchar(10) not null,customersince varchar(10) ,sin varchar(15), firstname varchar(30),lastname varchar(30),street varchar(30),city varchar(30),state varchar(30),country varchar(30),zipCode varchar(30),phoneNumber varchar(30),cashBalance double precision,maximumTransactionAmount double precision,constraint customers_pk primary key (customernumber) )"); 
      
     

     System.out.println("Creating STOCKS table...");                      
     stmt.execute( "create table stocks (customernumber varchar(10) not null, symbol varchar(5), quantity bigint )"); 
      
          
               
     System.out.println(" ");      
     
          
     
     
     //populate tables with data

 	String sCustomerNumber = null;
 	String sCustomerSince = null;
 	String sSIN = null; 	
	String sFirstName = null;
	String sLastName = null;
	
	String sStreet = null;
	String sCity = null;
	String sState = null;
	String sCountry = null;
	String sZip = null;
		
	
	String sPhoneNumber = null;
	Double cashBalance = null;
	Double maximumTransactionAmount = null;
	Integer numberOfStockSymbols = null;
	
	Integer[] quantityOfShares = null;
	String[] stockSymbols = null;

     
    String sCustOne = null;
    String sCustTwo = null;
    
     System.out.println("Inserting data into CUSTOMERS table...");
     
     sCustomerNumber = "9999000000";
     sCustOne = sCustomerNumber;
	 
     sCustomerSince = "1972/04/20";
     sSIN = "111111111";
     sFirstName = "John";
     sLastName = "Doe";
     

     sStreet  = "Street1";
     sCity    = "City1";
     sState   = "State1";     
     sCountry = "Country1";
     sZip     = "Zip1";
     sPhoneNumber     = "905-444-5555";
     cashBalance = new Double(0.0);
     maximumTransactionAmount = new Double(1050.45);

     
     
     stmt.execute( "insert into customers values ('" + sCustomerNumber + "','" + sCustomerSince + "','"  + sSIN + "','" + sFirstName + "','" + sLastName + "','" + sStreet + "','" + sCity + "','" + sState + "','" + sCountry + "','" + sZip + "','" + sPhoneNumber + "'," + cashBalance.doubleValue() + "," + maximumTransactionAmount.doubleValue()  + ")");

     sCustomerNumber = "9999000001";
     sCustTwo = sCustomerNumber;
     
     sCustomerSince = "1973/04/20";     
     sSIN = "111111112";
     sFirstName = "Jane";
     sLastName = "Doe";
     

     sStreet  = "Street2";
     sCity    = "City2";
     sState   = "State2";     
     sCountry = "Country2";
     sZip     = "Zip2";
     sPhoneNumber     = "905-444-5556";
     cashBalance = new Double(0.0);
     maximumTransactionAmount = new Double(1050.46);

     
     
     stmt.execute( "insert into customers values ('" + sCustomerNumber + "','"  + sCustomerSince + "','" +  sSIN + "','" + sFirstName + "','" + sLastName + "','" + sStreet + "','" + sCity + "','" + sState + "','" + sCountry + "','" + sZip + "','" + sPhoneNumber + "'," + cashBalance.doubleValue() + "," + maximumTransactionAmount.doubleValue()  + ")");
     
     System.out.println("Inserting data into STOCKS table...");

     stockSymbols = new String[]{"IBM","MSFT","BEA"};
     quantityOfShares = new Integer[]{new Integer(7),new Integer(8),new Integer(9)};
     

     for (int i = 0; i < stockSymbols.length; i++) {
        stmt.execute( "insert into stocks values ('" + sCustOne + "','" + stockSymbols[i] + "'," + quantityOfShares[i].intValue() + ")");		
	 }

     stockSymbols = new String[]{"ABC","DEF","GHI"};
     quantityOfShares = new Integer[]{new Integer(4),new Integer(5),new Integer(6)};
     
     for (int i = 0; i < stockSymbols.length; i++) {
        stmt.execute( "insert into stocks values ('" + sCustTwo + "','" + stockSymbols[i] + "'," + quantityOfShares[i].intValue() + ")");		
	 }
     
     //Display table info
     System.out.println("  ");     
     System.out.println("  ");     
     System.out.println("Displaying table data... ");               
     ResultSet result;

     System.out.println("   ");     
     System.out.println("SELECT * FROM CUSTOMERS:");   
     result = stmt.executeQuery("SELECT * FROM customers");

     
     
     while(result.next()) {
       System.out.println("   ");     	
       System.out.println("customernumber=" + result.getString("customernumber") + ",\n" +
       					  "customersince="  + result.getString("customersince") + ",\n" +
	                      "sin="      + result.getString("sin") + ",\n" +       		
       		              "firstname="      + result.getString("firstname") + ",\n" +
						  "lastname="       + result.getString("lastname")  + ",\n" +
						  "street="       + result.getString("street")  + ",\n" +
						  "city="       + result.getString("city")  + ",\n" +						  
						  "state="       + result.getString("state")  + ",\n" +
						  "country="       + result.getString("country")  + ",\n" +						  
						  "zipCode="       + result.getString("zipCode")  + ",\n" +
						  "cashBalance="       + result.getDouble("cashBalance")  + ",\n" +						  
						  "maximumTransactionAmount="       + result.getDouble("maximumTransactionAmount")  
						  
						  
         );
     }
     System.out.println(" ");          
     System.out.println(" ");          
     
     
     System.out.println("SELECT * FROM STOCKS:");          
     result = stmt.executeQuery("SELECT * FROM stocks");
     while(result.next()) {
       System.out.println("customernumber=" + result.getString("customernumber") + "," +
						  "symbol=" + result.getString("symbol") + ", " +
						  "quantity=" + result.getLong("quantity")						  
						  );
     }
     System.out.println(" ");          
     System.out.println(" ");          


     finishUp();
          
     System.out.println("Successfully shut down " + BrokerageDatabaseConstants.sDatabaseName + " database");     


  }//try
  catch(Throwable e) {
     System.out.println("Exception thrown.");
     System.out.println(e);
  }//catch
		
		
}

    private static void startDB() {

        try {    	
        	
        	
           //make sure db is created: use this style of URL -> jdbc:db2j:c:\cloudscapedbs\eMergedScenarioBankAccountDB;create=true
           Class.forName("com.ibm.db2j.jdbc.DB2jDriver").newInstance();             	  
           Connection temp = DriverManager.getConnection("jdbc:db2j:" + BrokerageDatabaseConstants.sDBPath + sFileSeparator + BrokerageDatabaseConstants.sDatabaseName + ";create=true");        	  
        	
           Class cds = Class.forName("com.ibm.db2j.jdbc.DB2jDataSource");
           ds = (com.ibm.db2j.jdbc.DB2jDataSource) cds.newInstance();
           ds.setDatabaseName(BrokerageDatabaseConstants.sDBPath + sFileSeparator + BrokerageDatabaseConstants.sDatabaseName);
            
        }
        catch(Exception e) {
               e.printStackTrace();
        }
    	
    }
        
    private static void closeDB()  {
    	
     try {

         if ( c != null) {         	
             c.close();
             c = null;
         }

     }
     catch(Exception e) {
     	e.printStackTrace();
     }

     try {
         DriverManager.getConnection("jdbc:db2j:" + BrokerageDatabaseConstants.sDBPath + sFileSeparator + BrokerageDatabaseConstants.sDatabaseName + ";shutdown=true");        	                	
     }
     catch(Exception e) {
     	//shutting down always throws an exception
     }    	    	
    	
    }

    private static void startUp()  {
    	
       startDB();	    	
    	
    }

    private static void finishUp()  {
    	
       closeDB();
    	
    }
    
     private static Connection getConnection() {

       try {
       	
          if ( c == null) {
   	           c = ds.getConnection();                	
          }
       }
       catch(Exception e) {
       	 e.printStackTrace();
       }

       return c;
          
     }
    


}
