package ruleset;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;

import com.ibm.wbiserver.brules.BusinessRule;
import com.ibm.wbiservers.brules.core.codegen.runtime.GeneratedRuleLogic;
import com.ibm.wbiservers.brules.core.codegen.NillableUtility;
import com.ibm.wbit.br.core.model.Rule;
import com.ibm.wbit.br.core.model.RuleBlock;
import com.ibm.wbit.br.core.model.RuleLogic;
import com.ibm.wbit.br.core.model.RuleSet;
import com.ibm.wbit.br.core.model.Table;
import com.ibm.wbit.br.core.model.TemplateInstanceRule;
import com.ibm.wbit.br.core.model.ParameterValue;



import com.ibm.websphere.bo.BOFactory;

import com.ibm.websphere.sca.ServiceBusinessException;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.sca.scdl.OperationType;


import com.ibm.websphere.sca.sdo.DataFactory;
import commonj.sdo.DataObject;


public class Autoapproval extends GeneratedRuleLogic 
	implements BusinessRule {
	
	Map booleanMap = new HashMap();

	ServiceManager serviceManager = new ServiceManager();
	BOFactory dataFactory = (BOFactory) serviceManager
			.locateService("com/ibm/websphere/bo/BOFactory");
	// Utility methods
	private String getRuleID(int ruleIndex, String[] stringArray) {
		if (ruleIndex < stringArray.length) {
			return stringArray[ruleIndex];
		} else {
			return "-1";
		}	
	}

	// input parameters
	DataObject applicationInformation;
	
	
	// Declare output variables and initialize DataObject output variables.
	java.lang.Boolean response;
	
	Object iBMGenResult = null;
	
	// local variables
	
	private boolean trace(String key, boolean value) {
		booleanMap.put(key, new Boolean(value));

		return value;
	}
	private String[] ruleIDs = new String[] {"2", "5"};
	
	private HashMap ruleLabelMap = null;

	public Object execute(OperationType opType, Object inputObject,
			EObject ruleLogic) throws ServiceBusinessException {
		
		// Init rule set.
		
		if (opType.isWrapperType(opType.getInputType())) {
			this.applicationInformation = (DataObject) ((DataObject) inputObject).getDataObject("applicationInformation");
		} else {
			this.applicationInformation = (DataObject) inputObject;
		}

		
		initRuleLabelMap();
		
		// Run rules.
		runRules((RuleLogic) ruleLogic);
		
		// Return iBMGenResult
	
		if (opType.isWrapperType(opType.getOutputType())) {
			DataObject resultDO = DataFactory.INSTANCE.create(opType.getOutputType());
			resultDO.set("response", response);
			iBMGenResult = resultDO;
		} else {
			iBMGenResult = response;
		}

		return iBMGenResult;
	}

private boolean Rule1() {
	if (true) {
		
		response = new java.lang.Boolean(false);
	
		trace("4", true);
	
		return true;
	}
	return false;
}

private boolean Rule2() {
	if (trace("7", NillableUtility.getDataObject(applicationInformation, "applicationInformation").getDouble("loanamount") <= 50000)) {
		
		response = new java.lang.Boolean(true);
	
		trace("9", true);
	
		return true;
	}
	return false;
}



	private void initRuleLabelMap() {
		ruleLabelMap = new HashMap(25);
		ruleLabelMap.put("Rule1", new Integer(1));
		ruleLabelMap.put("Rule2", new Integer(2));

	}

	public String[][] readData(RuleLogic ruleLogic) {
		List ruleBlockList = ((RuleSet) ruleLogic).getRuleBlock();
		if (ruleBlockList.isEmpty())
			return new String[0][0];

		RuleBlock ruleBlock = (RuleBlock) ruleBlockList.get(0);
		List rules = ruleBlock.getRule();
		String[][] result = new String[rules.size()][];
		for (int i = 0; i < rules.size(); i++) {
			Rule rule = (Rule) rules.get(i);
			if (rule instanceof TemplateInstanceRule) {
				TemplateInstanceRule templateInstanceRule = (TemplateInstanceRule) rule;
				List parameters = templateInstanceRule.getParameterValue();
				String[] values = new String[parameters.size() + 1];
				int caseIndex = ((RuleSet) ruleLogic).getTemplate().indexOf(templateInstanceRule.getTemplateRef());
				//Template index run from -1 to -n where the first template is index -1 and the last is -n
				caseIndex = (caseIndex + 1) * -1;
				values[0] = String.valueOf(caseIndex);
				for (int j = 0; j < parameters.size(); j++) {
					values[j+1] = ((ParameterValue) parameters.get(j)).getValue().getValue(); 
				}
				result[i] = values;
			} else {
			    // Use the rule label map to get the case index corresponding to this rule.
				String[] values = new String[1];
				String ruleLabel = rule.getLabel();
				Integer index = (Integer) ruleLabelMap.get(ruleLabel);
				values[0] = index.toString();
				result[i] = values;
			}
		}
		
		return result;
	}

	private void runRules(RuleLogic ruleLogic) { 
		/* Read a chunk of data from the runtime (xml, text, whatever)
		   and convert the data into String[][] */
		String[][] data = readData(ruleLogic);
		String ruleID;
		for (int i = 0; i < data.length; i++) {
			String[] params = data[i]; 
			switch (new Integer(params[0]).intValue()) {
				case 1:
					trace("2", Rule1());
					break;
			case 2:
					trace("5", Rule2());
					break;
			
			}
		}
	}
	
	protected String[][] generateConfigConditionData(Table table, 
		int conditionIndex) {
		
		// This routine is not used for rule sets
		return null;
	}
	
	private DataObject createBO(String uRL, String bOName) {
		return dataFactory.create(uRL, bOName);
	}
}
