package com.emerged.trading.dtable;

import java.util.HashMap;

import java.util.Map;

import org.eclipse.emf.ecore.EObject;

import com.ibm.wbiserver.brules.BusinessRule;
import com.ibm.wbiservers.brules.core.codegen.runtime.GeneratedRuleLogic;
import com.ibm.wbiservers.brules.core.codegen.NillableUtility;




import com.ibm.wbit.br.core.model.Table;





import com.ibm.websphere.bo.BOFactory;

import com.ibm.websphere.sca.ServiceBusinessException;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.sca.scdl.OperationType;


import com.ibm.websphere.sca.sdo.DataFactory;
import commonj.sdo.DataObject;


public class Authorize extends GeneratedRuleLogic 
	implements BusinessRule {
	
	Map booleanMap = new HashMap();

	ServiceManager serviceManager = new ServiceManager();
	BOFactory dataFactory = (BOFactory) serviceManager
			.locateService("com/ibm/websphere/bo/BOFactory");
	// Utility methods
	private String getRuleID(int ruleIndex, String[] stringArray) {
		if (ruleIndex < stringArray.length) {
			return stringArray[ruleIndex];
		} else {
			return "-1";
		}	
	}

	// input parameters
	DataObject brokerageAccount;
	DataObject transactionAmount;
	
	
	// Declare output variables and initialize DataObject output variables.
	DataObject authorized = dataFactory.create("http://eMergedLibrary/com/emerged/portal", "TrueOrFalseBO");
	
	Object iBMGenResult = null;
	
	// local variables
	
	private boolean trace(String key, boolean value) {
		booleanMap.put(key, new Boolean(value));

		return value;
	}

	public Object execute(OperationType opType, Object inputObject, 
		EObject ruleLogic) 
		throws ServiceBusinessException {
		
		// initialize the input variables
		DataObject inputDataObject = (DataObject) inputObject;
		this.brokerageAccount = (DataObject) inputDataObject.getDataObject("brokerageAccount");
		this.transactionAmount = (DataObject) inputDataObject.getDataObject("transactionAmount");

		
		// evaluate each condition
		int indexCondition1 = evaluateCondition1((Table) ruleLogic);
		
		// invoke each action
		invokeAction1(indexCondition1, (Table) ruleLogic);
		
		// return iBMGenResult
		
		if (opType.isWrapperType(opType.getOutputType())) {
			DataObject resultDO = DataFactory.INSTANCE.create(opType.getOutputType());
			resultDO.set("authorized", authorized);
			iBMGenResult = resultDO;
		} else {
			iBMGenResult = authorized;
		}

		return iBMGenResult;
	}

	private int evaluateCondition1(Table table) 
		throws ServiceBusinessException {
		
		String[] ruleIds = {"8", "10"};
		String[][] data = readConditionData(1, table);
		
		//evaluate the condition term partial expression
		String[] termParams = data[0];
		java.lang.Double termValue = (java.lang.Double) transactionAmount.get("value");
		
		//evaluate each condition case until one succeeds
		//start at 1 because first array is for condition term
		for (int i = 1; i < data.length; i++) {
			String[] valueParams = data[i];
			String ruleID = getRuleID(i - 1, ruleIds);
			switch (Integer.parseInt(valueParams[0])) {
				case 0 :
					if (trace(ruleID, NillableUtility.compareNillableValues(transactionAmount.get("value"), brokerageAccount.get("transactionTradingLimit"), NillableUtility.LESS_THAN_OR_EQUAL_OPERATOR))) { 
						return i - 1;
					}
					break;
				case 1 :
					if (trace(ruleID, NillableUtility.compareNillableValues(transactionAmount.get("value"), brokerageAccount.get("transactionTradingLimit"), NillableUtility.GREATER_THAN_OPERATOR))) { 
						return i - 1;
					}
					break;

			}
		}
		
		//no condition cases evaluated to true
		throw new ServiceBusinessException(new IllegalStateException("No condition cases evaluated to true."));
	}

	private void invokeAction1(int indexCondition1, Table table)  
		throws ServiceBusinessException {
		
		int[] caseEdgeIndices = {indexCondition1};
		String[] valueParams = 
			readActionData(1, caseEdgeIndices, table);
		
		String[] ruleIds = {"15", "19"};
		String ruleID = getRuleID(getActionNodeIndex(caseEdgeIndices, table), ruleIds);

		//evaluate the action
		switch (Integer.parseInt(valueParams[0])) {
				case 0 :
					authorized.set("value", new java.lang.Boolean(true)); 
					trace(ruleID, true);

					break;
				case 1 :
					authorized.set("value", new java.lang.Boolean(false)); 
					trace(ruleID, true);

					break;

		}
	}
	



	
	private DataObject createBO(String uRL, String bOName) {
		return dataFactory.create(uRL, bOName);
	}
}
