package com.emerged.trading.ruleset;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;

import com.ibm.wbiserver.brules.BusinessRule;
import com.ibm.wbiservers.brules.core.codegen.runtime.GeneratedRuleLogic;
import com.ibm.wbiservers.brules.core.codegen.NillableUtility;
import com.ibm.wbit.br.core.model.Rule;
import com.ibm.wbit.br.core.model.RuleBlock;
import com.ibm.wbit.br.core.model.RuleLogic;
import com.ibm.wbit.br.core.model.RuleSet;
import com.ibm.wbit.br.core.model.Table;
import com.ibm.wbit.br.core.model.TemplateInstanceRule;
import com.ibm.wbit.br.core.model.ParameterValue;



import com.ibm.websphere.bo.BOFactory;

import com.ibm.websphere.sca.ServiceBusinessException;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.sca.scdl.OperationType;


import com.ibm.websphere.sca.sdo.DataFactory;
import commonj.sdo.DataObject;


public class GetCommission extends GeneratedRuleLogic 
	implements BusinessRule {
	
	Map booleanMap = new HashMap();

	ServiceManager serviceManager = new ServiceManager();
	BOFactory dataFactory = (BOFactory) serviceManager
			.locateService("com/ibm/websphere/bo/BOFactory");
	// Utility methods
	private String getRuleID(int ruleIndex, String[] stringArray) {
		if (ruleIndex < stringArray.length) {
			return stringArray[ruleIndex];
		} else {
			return "-1";
		}	
	}

	// input parameters
	DataObject commissionInfo;
	
	
	// Declare output variables and initialize DataObject output variables.
	DataObject cashAmount = dataFactory.create("http://eMergedLibrary/com/emerged/portal", "CashAmountBO");
	
	Object iBMGenResult = null;
	
	// local variables
	
	private boolean trace(String key, boolean value) {
		booleanMap.put(key, new Boolean(value));

		return value;
	}
	private String[] ruleIDs = new String[] {"2", "5", "12"};
	
	private HashMap ruleLabelMap = null;

	public Object execute(OperationType opType, Object inputObject,
			EObject ruleLogic) throws ServiceBusinessException {
		
		// Init rule set.
		
		if (opType.isWrapperType(opType.getInputType())) {
			this.commissionInfo = (DataObject) ((DataObject) inputObject).getDataObject("commissionInfo");
		} else {
			this.commissionInfo = (DataObject) inputObject;
		}

		
		initRuleLabelMap();
		
		// Run rules.
		runRules((RuleLogic) ruleLogic);
		
		// Return iBMGenResult
	
		if (opType.isWrapperType(opType.getOutputType())) {
			DataObject resultDO = DataFactory.INSTANCE.create(opType.getOutputType());
			resultDO.set("cashAmount", cashAmount);
			iBMGenResult = resultDO;
		} else {
			iBMGenResult = cashAmount;
		}

		return iBMGenResult;
	}

	private boolean template0(String ruleInstanceID, double totalCashWorth, double commissionToCharge) {
		if (trace(ruleInstanceID + "|19", NillableUtility.getDataObject(commissionInfo, "commissionInfo").getDouble("totalCashValue") >= totalCashWorth)) {
			
		NillableUtility.getDataObject(cashAmount, "cashAmount").setDouble("value", commissionToCharge);
	
		trace(ruleInstanceID + "|21", true);
	
			return true;
		}
		return false;
	}
		private boolean template1(String ruleInstanceID, int yearsLoyal, double totalWorthStock, double commissionToCharge) {
		if (trace(ruleInstanceID + "|24", (trace("25", NillableUtility.getDataObject(commissionInfo, "commissionInfo").getInt("yearsLoyalCustomer") >= yearsLoyal)) && 
			(trace("26", NillableUtility.getDataObject(commissionInfo, "commissionInfo").getDouble("totalPortfolioValue") >= totalWorthStock)))) {
			
		NillableUtility.getDataObject(cashAmount, "cashAmount").setDouble("value", commissionToCharge);
	
		trace(ruleInstanceID + "|28", true);
	
			return true;
		}
		return false;
	}
		private boolean template2(String ruleInstanceID, double commissionToCharge) {
		if (true) {
			
		NillableUtility.getDataObject(cashAmount, "cashAmount").setDouble("value", commissionToCharge);
	
		trace(ruleInstanceID + "|31", true);
	
			return true;
		}
		return false;
	}
	

	private void initRuleLabelMap() {
		ruleLabelMap = new HashMap(25);
		
	}

	public String[][] readData(RuleLogic ruleLogic) {
		List ruleBlockList = ((RuleSet) ruleLogic).getRuleBlock();
		if (ruleBlockList.isEmpty())
			return new String[0][0];

		RuleBlock ruleBlock = (RuleBlock) ruleBlockList.get(0);
		List rules = ruleBlock.getRule();
		String[][] result = new String[rules.size()][];
		for (int i = 0; i < rules.size(); i++) {
			Rule rule = (Rule) rules.get(i);
			if (rule instanceof TemplateInstanceRule) {
				TemplateInstanceRule templateInstanceRule = (TemplateInstanceRule) rule;
				List parameters = templateInstanceRule.getParameterValue();
				String[] values = new String[parameters.size() + 1];
				int caseIndex = ((RuleSet) ruleLogic).getTemplate().indexOf(templateInstanceRule.getTemplateRef());
				//Template index run from -1 to -n where the first template is index -1 and the last is -n
				caseIndex = (caseIndex + 1) * -1;
				values[0] = String.valueOf(caseIndex);
				for (int j = 0; j < parameters.size(); j++) {
					values[j+1] = ((ParameterValue) parameters.get(j)).getValue().getValue(); 
				}
				result[i] = values;
			} else {
			    // Use the rule label map to get the case index corresponding to this rule.
				String[] values = new String[1];
				String ruleLabel = rule.getLabel();
				Integer index = (Integer) ruleLabelMap.get(ruleLabel);
				values[0] = index.toString();
				result[i] = values;
			}
		}
		
		return result;
	}

	private void runRules(RuleLogic ruleLogic) { 
		/* Read a chunk of data from the runtime (xml, text, whatever)
		   and convert the data into String[][] */
		String[][] data = readData(ruleLogic);
		String ruleID;
		for (int i = 0; i < data.length; i++) {
			String[] params = data[i]; 
			switch (new Integer(params[0]).intValue()) {
				case -1:
				ruleID = getRuleID(i, ruleIDs);
				trace(ruleID, template0(ruleID, Double.parseDouble(params[1]), Double.parseDouble(params[2])));
				break;
			case -2:
				ruleID = getRuleID(i, ruleIDs);
				trace(ruleID, template1(ruleID, Integer.parseInt(params[1]), Double.parseDouble(params[2]), Double.parseDouble(params[3])));
				break;
			case -3:
				ruleID = getRuleID(i, ruleIDs);
				trace(ruleID, template2(ruleID, Double.parseDouble(params[1])));
				break;
			}
		}
	}
	
	protected String[][] generateConfigConditionData(Table table, 
		int conditionIndex) {
		
		// This routine is not used for rule sets
		return null;
	}
	
	private DataObject createBO(String uRL, String bOName) {
		return dataFactory.create(uRL, bOName);
	}
}
