/*
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 

package com.emerged.bank;

/**
 * @author dominique
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

import java.sql.*;
import java.util.Vector;





public class BankDatabaseBean {

      private com.ibm.db2j.jdbc.DB2jDataSource ds = null;
      private Connection c = null;
	  private String sFileSeparator = java.io.File.separator;
	      
	  
	  private String sRowID = null;

	  

	public BankDatabaseBean() {
		super();		
		
		try {
		   getDataSource();	
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

    private void getDataSource() throws Exception {

        try {    	
        	
        	
           Class cds = Class.forName("com.ibm.db2j.jdbc.DB2jDataSource");
           ds = (com.ibm.db2j.jdbc.DB2jDataSource) cds.newInstance();
           ds.setDatabaseName(BankDatabaseConstants.sDBPath + sFileSeparator + BankDatabaseConstants.sDatabaseName);

                
        }
        catch(Exception e) {
               throw e;
        }
    	
    }
    
    private void extraStuff4Linux() {
    	
    	 /*
    	  *  This code is linux/cloudscape workaround.
    	  *  It is used to avoid getting the following message:
    	  *  WARNING: Cloudscape (instance c013800d-00f2-15b3-5c65-00091aa1ce00) is attempting to boot the database /home/userid/cloudscapedbs/eMergedScenarioBankAccountDB even though Cloudscape (instance c013800d-00f2-15b3-1356-00091aa1ce00) may still be active.  Only one instance of Cloudscape should boot a database at a time. Severe and non-recoverable corruption can result and may have already occurred.
    	  * 
    	  */ 
    	
	     try {
	         DriverManager.getConnection("jdbc:db2j:" + BankDatabaseConstants.sDBPath + sFileSeparator + BankDatabaseConstants.sDatabaseName + ";shutdown=true");        	                	
	     }
	     catch(Exception e) {
	     	//shutting down always throws an exception
	     }    	    	
    	
    }
    
    private void closeConnection()  throws Exception {
    	
     try {

         if ( c != null) {         	
             c.close();
             c = null;
         }
         
         extraStuff4Linux();

     }
     catch(Exception e) {
     	throw e;
     }
    	
    }

     private Connection getConnection() throws Exception {

       try {
       	
          if ( c == null) {
   	           c = ds.getConnection();                	
          }
       }
       catch(Exception e) {
       	 throw e;
       }

       return c;
          
     }
    
     public ContactInfo createContactInfo(ContactInfo input) throws Exception {
     	
         try {


            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;


            
            sRowID = input.getCustomerNumber();
            
            //create the new contactinfo record for this customer
            //i.e.
            //insert into contactinfo values ('9999000000','Street1','City1','State1','Country1','Zip1','905-201-7999','913-222-4444','johndoe@whatever.com')
            String sInsertSQL = null;   
            sInsertSQL = "insert into contactinfo values (?,?,?,?,?,?,?,?,?)";
            sInsertSQL = sInsertSQL.toUpperCase();            
            ptstmt = con.prepareStatement(sInsertSQL);
            
            input.setCustomerNumber( sRowID );
            ptstmt.setString(1, input.getCustomerNumber());
            ptstmt.setString(2, input.getStreet() );
            ptstmt.setString(3, input.getCity() );
            ptstmt.setString(4, input.getState() );
            ptstmt.setString(5, input.getCountry() );
            ptstmt.setString(6, input.getZip() );            
            ptstmt.setString(7, input.getHomePhoneNumber() );
            ptstmt.setString(8, input.getWorkPhoneNumber() );
            ptstmt.setString(9, input.getEmail() );            
            ptstmt.executeUpdate();
                        
            ptstmt.close();                     


            closeConnection();
            
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        return input;
     }

     public ContactInfo retrieveContactInfo(ContactInfo input) throws Exception {
     	
         try {

            boolean bRecordFound = false;
            
            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;
            ResultSet rs = null;

            
	          //retrieve the contactinfo
	          //i.e.
	          // select customernumber,street,city,state,country,zip,homephone,workphone,email from contactinfo where customernumber = ?
	          String sSelectSQL = null;            
	          sSelectSQL = "select customernumber,street,city,state,country,zip,homephone,workphone,email from contactinfo where customernumber = ?";
	          sSelectSQL = sSelectSQL.toUpperCase();            
	          
	        ptstmt = con.prepareStatement(sSelectSQL);
	        ptstmt.setString(1, input.getCustomerNumber() );
	        rs = ptstmt.executeQuery();
	        while (rs.next()) {
	          bRecordFound = true;
	          input.setCustomerNumber( rs.getString("customernumber") );	            	
	          input.setStreet( rs.getString("street") );
	          input.setCity( rs.getString("city") );
	          input.setState( rs.getString("state") );
	          input.setCountry( rs.getString("country") );	              
	          input.setZip( rs.getString("zip") );
	          input.setHomePhoneNumber( rs.getString("homephone") );
	          input.setWorkPhoneNumber( rs.getString("workphone") );
	          input.setEmail( rs.getString("email") );	          
	        }//while

	        rs.close();
            ptstmt.close();                     

            closeConnection();

            if (!bRecordFound) {
            	input = new ContactInfo();
            }
            
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        
        
        return input;
     }
            

     public Account retrieveAccount(Account input) throws Exception {
     	
         try {

            boolean bRecordFound = false;
            
            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;
            ResultSet rs = null;

            
	          //retrieve the account
	          //i.e.
	          // select accountnumber,balance,type,maxDailyWithdrawalLimit,description from accounts,accountdescriptions where accountnumber = ? and accounts.type=accountdescriptions.type
	          String sSelectSQL = null;            
	          sSelectSQL = "select accountnumber,balance,accounts.type,maxDailyWithdrawalLimit,description from accounts,accountdescriptions where accountnumber = ? and accounts.type=accountdescriptions.type";
	          sSelectSQL = sSelectSQL.toUpperCase();            
	          
	        ptstmt = con.prepareStatement(sSelectSQL);
	        ptstmt.setString(1, input.getAccountNumber() );
	        rs = ptstmt.executeQuery();
	        while (rs.next()) {
	          bRecordFound = true;
	          input.setAccountNumber( rs.getString("accountnumber") );	            	
	          input.setBalance( new Double(rs.getDouble("balance")) );
	          input.setType( rs.getString("type") );
	          input.setDescription( rs.getString("description") );	          
	          input.setMaximumDailyWithdrawalLimit( new Double(rs.getDouble("maxDailyWithdrawalLimit")) );	              
	        }//while

	        rs.close();
            ptstmt.close();                     
            closeConnection();
            
            if (!bRecordFound) {
            	input = new Account();
            }

	        
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        return input;
     }
     
     public Customer retrieveCustomer(Customer input) throws Exception {
     	
         try {

            boolean bRecordFound = false;
            
            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;
            ResultSet rs = null;

            //retrieve the customer            
            if (input.getCustomerNumber() != null) {
            	
  	          // select customernumber,dateprofilecreated,sin,firstname,lastname from customers where customernumber = ?
  	          String sSelectSQL = null;            
  	          sSelectSQL = "select customernumber,dateprofilecreated,sin,firstname,lastname from customers where customernumber = ?";
  	          sSelectSQL = sSelectSQL.toUpperCase();            
  	          
  	          ptstmt = con.prepareStatement(sSelectSQL);
  	          ptstmt.setString(1, input.getCustomerNumber() );
            	
            }//if
            else if (input.getSIN() != null) {
            	
  	          // select customernumber,dateprofilecreated,sin,firstname,lastname from customers where sin = ?
  	          String sSelectSQL = null;            
  	          sSelectSQL = "select customernumber,dateprofilecreated,sin,firstname,lastname from customers where sin = ?";
  	          sSelectSQL = sSelectSQL.toUpperCase();            
  	          
  	          ptstmt = con.prepareStatement(sSelectSQL);
  	          ptstmt.setString(1, input.getSIN() );
            	
            }//endif

            
	        rs = ptstmt.executeQuery();
	        while (rs.next()) {
	          bRecordFound = true;
	          input.setCustomerNumber( rs.getString("customernumber") );
	          input.setDateProfileCreated( rs.getString("dateprofilecreated") );	          
	          input.setSIN( rs.getString("sin") );	          
	          input.setFName( rs.getString("firstname") );
	          input.setLName( rs.getString("lastname") );
	        }//while

	        rs.close();
            ptstmt.close();                     
            closeConnection();
            
            if (!bRecordFound) {
            	input = new Customer();
            }//if
            else {
            	
	            //get contact info 
	            ContactInfo ci = new ContactInfo();
	            ci.setCustomerNumber(  input.getCustomerNumber() );
	            
	            input.setContactInfo( retrieveContactInfo( ci ) );
	            
	            //get accounts
	            Account[] accounts = getAccounts( input );
	            input.setAccounts( accounts );
            
            }//endif
            
            
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        return input;
     }
     
     public ContactInfo updateContactInfo(ContactInfo input) throws Exception {
     	
         try {


            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;


            
	          //update contactinfo
	          //i.e.
	          // update contactinfo  set street = ?, city = ?, state = ?, country = ?, zip = ?, homephone = ?,workphone = ?,email = ? where customernumber = ?
	          String sUpdateSQL = null;            
	          sUpdateSQL = "update contactinfo  set street = ?, city = ?, state = ?, country = ?, zip = ?, homephone = ?,workphone = ?,email = ? where customernumber = ?";
	          sUpdateSQL = sUpdateSQL.toUpperCase();            
	          
	          ptstmt = con.prepareStatement(sUpdateSQL);
	          ptstmt.setString(1, input.getStreet() );
	          ptstmt.setString(2, input.getCity() );
	          ptstmt.setString(3, input.getState() );
	          ptstmt.setString(4, input.getCountry() );
	          ptstmt.setString(5, input.getZip() );
	          ptstmt.setString(6, input.getHomePhoneNumber() );
	          ptstmt.setString(7, input.getWorkPhoneNumber() );
	          ptstmt.setString(8, input.getEmail() );	          
	          ptstmt.setString(9, input.getCustomerNumber() );          
	          
	          ptstmt.executeUpdate();

            ptstmt.close();                     


            closeConnection();
            
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        return input;
     }
     
     private String getAccountDescription(String sType) throws Exception {
     	
     	String sDescription = null;
     	try {
     		
            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;
            ResultSet rs = null;
            
            //get description of account
            String sAccountDescriptionSQL = "select type,description from accountdescriptions where type = ?";
            ptstmt = con.prepareStatement(sAccountDescriptionSQL);
            ptstmt.setString(1, sType );
            rs = ptstmt.executeQuery();
            while (rs.next()) {
              sDescription = rs.getString(2);
            }//while
            
            ptstmt.close();                     
            rs.close();

            closeConnection();
     		
     	}
     	catch(Exception e) {
     		throw e;
     	}
     	
     	return sDescription;
     }
     
     public Account updateAccount(Account input) throws Exception {
     	
         try {

            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;


            
	          //update the account info
	          //i.e.
	          // update accounts  set balance = ?, type = ?, maxDailyWithdrawalLimit = ? where accountnumber = ?
	          String sUpdateSQL = null;            
	          sUpdateSQL = "update accounts set  balance = ?, type = ?, maxDailyWithdrawalLimit = ? where accountnumber = ?";
	          sUpdateSQL = sUpdateSQL.toUpperCase();            
	          
	          ptstmt = con.prepareStatement(sUpdateSQL);
	          ptstmt.setDouble(1, input.getBalance().doubleValue() );
	          ptstmt.setString(2, input.getType() );
	          ptstmt.setDouble(3, input.getMaximumDailyWithdrawalLimit().doubleValue() );
	          ptstmt.setString(4, input.getAccountNumber() );	          
	          ptstmt.executeUpdate();

              ptstmt.close();                     
              closeConnection();
              
	          input.setDescription( getAccountDescription( input.getType() ) );
            
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        return input;
     }
     
     public Customer updateCustomer(Customer input) throws Exception {
     	
         try {

         	

            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;


            
	          //update the customer info
	          //i.e.
	          // update customers set dateprofilecreated = ?, sin = ?, firstname = ?, lastname = ? where customernumber = ?
	          String sUpdateSQL = null;            
	          sUpdateSQL = "update customers set dateprofilecreated = ?, sin = ?, firstname = ?, lastname = ? where customernumber = ?";
	          sUpdateSQL = sUpdateSQL.toUpperCase();            
	          
	          ptstmt = con.prepareStatement(sUpdateSQL);
	          ptstmt.setString(1, input.getDateProfileCreated() );	          
	          ptstmt.setString(2, input.getSIN() );	          
	          ptstmt.setString(3, input.getFName() );
	          ptstmt.setString(4, input.getLName() );	          
	          ptstmt.setString(5, input.getCustomerNumber() );
	          ptstmt.executeUpdate();


            ptstmt.close();                     

            closeConnection();
            
        	//update the customer's contactinfo
            input.setContactInfo(  updateContactInfo( input.getContactInfo() )  );

            
            
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        return input;
     }
     
     public ContactInfo deleteContactInfo(ContactInfo input) throws Exception {
     	
     	ContactInfo returnValue = null;
		
         try {

         	
         	
            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;

          //delete contactinfo
          //i.e.
          // delete from contactinfo  where customernumber = ?
          String sDeleteSQL = null;            
          sDeleteSQL = "delete from contactinfo  where customernumber = ?";
          sDeleteSQL = sDeleteSQL.toUpperCase();            
          
          ptstmt = con.prepareStatement(sDeleteSQL);
          ptstmt.setString(1, input.getCustomerNumber() );                                                
          ptstmt.executeUpdate();

          ptstmt.close();                     

          closeConnection();
           
          returnValue = new ContactInfo();          
          returnValue.setCustomerNumber(input.getCustomerNumber());
          
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        
        return returnValue;
     }

     public Account deleteAccount(Customer c,Account input) throws Exception {
     	 Account returnValue = null;
     	 
         try {

            Connection con = getConnection();
            PreparedStatement ptstmt = null;
            String sDeleteSQL = null;
          //delete this account
            

          // delete from accounts  where accountnumber = ?
            
          sDeleteSQL = "delete from accounts  where accountnumber = ?";
          sDeleteSQL = sDeleteSQL.toUpperCase();            
          
          ptstmt = con.prepareStatement(sDeleteSQL);
          ptstmt.setString(1, input.getAccountNumber() );                                                
          ptstmt.executeUpdate();

          // delete from customeraccounts  where customernumber = ? and accountnumber = ?
          sDeleteSQL = null;            
          sDeleteSQL = "delete from customeraccounts  where customernumber = ? and accountnumber = ?";
          sDeleteSQL = sDeleteSQL.toUpperCase();            
          
          ptstmt = con.prepareStatement(sDeleteSQL);
          ptstmt.setString(1, c.getCustomerNumber() );                                                
          ptstmt.setString(2, input.getAccountNumber() );          
          ptstmt.executeUpdate();
          
          
          ptstmt.close();                     
          closeConnection();
          
          returnValue = new Account();
          returnValue.setAccountNumber(input.getAccountNumber());
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        return returnValue;
     }

     public Customer deleteCustomer(Customer input) throws Exception {
     	
     	 Customer returnValue = null;
     	 
         try {

            input = retrieveCustomer( input );//just in case the Customer input variable isn't completely initialized
         	

            
          //delete contactinfo
          deleteContactInfo( input.getContactInfo() );

          
          //delete accounts
          Account[] accounts = input.getAccounts();
          for (int i = 0; i < accounts.length; i++) {
			 deleteAccount( input, accounts[i] );
		  }//for
          
          Connection con = getConnection();
          PreparedStatement ptstmt = null;
          
          //delete this customer
          //i.e.
          // delete from customers  where customernumber = ?
          String sDeleteSQL = null;            
          sDeleteSQL = "delete from customers  where customernumber = ?";
          sDeleteSQL = sDeleteSQL.toUpperCase();            
          
          ptstmt = con.prepareStatement(sDeleteSQL);
          ptstmt.setString(1, input.getCustomerNumber() );                                                
          ptstmt.executeUpdate();

          ptstmt.close();                     
          closeConnection();
         
          returnValue = new Customer();
          returnValue.setCustomerNumber(input.getCustomerNumber());
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        return returnValue;
     }
     
     
     public Customer createCustomer(Customer input) throws Exception {
     	
        
        try {

            PreparedStatement ptstmt = null;
            ResultSet         rs     = null;
            
            Connection con = getConnection();            
            String sCountSQL = "select count(customernumber) from customers";
            sCountSQL = sCountSQL.toUpperCase();                                    
            long iCustomers = -1;
            

            
            //get number of rows (customers)            
            ptstmt = con.prepareStatement(sCountSQL);
            rs = ptstmt.executeQuery();
            while (rs.next()) {
            	iCustomers = rs.getLong(1);
            }//while

            
            if (iCustomers == 0) {
               sRowID = BankDatabaseConstants.sFirstCustomerID;                 
            }//if                       
            else {//find biggest and increment by 1
                
               String sMAXSQL = "select max(customernumber) from customers";
               sMAXSQL = sMAXSQL.toUpperCase(); 
               long iCurrentMax = -1;
               long iNewMax = -1;
               
               //get max customernumber           
               ptstmt = con.prepareStatement(sMAXSQL);
               rs = ptstmt.executeQuery();
               while (rs.next()) {
                iCurrentMax = rs.getLong(1);
               }//while
                                
               iNewMax = (iCurrentMax + 1);
                                
               sRowID = new Long(iNewMax).toString();             
                
            }//endif

 
            //create the new customer            
            //i.e.
            //insert into customers values ('9999000000','1979/08/25','sin','FirstName','LastName')
             
            String sInsertSQL = null;
            sInsertSQL = "insert into customers values (?,?,?,?,?)";
            sInsertSQL = sInsertSQL.toUpperCase();            
            ptstmt = con.prepareStatement(sInsertSQL);
            
            input.setCustomerNumber( sRowID );
            ptstmt.setString(1, input.getCustomerNumber() );
            ptstmt.setString(2, input.getDateProfileCreated() );            
            ptstmt.setString(3, input.getSIN() );            
            ptstmt.setString(4, input.getFName() );
            ptstmt.setString(5, input.getLName() );
            ptstmt.executeUpdate();
                        
            ptstmt.close();                     
            rs.close();
            closeConnection();

        	//create this customer contactinfo
            input.getContactInfo().setCustomerNumber( sRowID );
            input.setContactInfo(  createContactInfo( input.getContactInfo() )  );
            
            //create accounts
            Account[] accounts = input.getAccounts();
        	for(int i=0;i<accounts.length;i++) {
        		accounts[i] = createAccount( input, accounts[i] );
        	}//for
            
        }//try
        catch(Exception e) {
        	throw e;        	
        }//catch
        
     	return input;
     }
     
     public Account createAccount(Customer c,Account input) throws Exception {
             
        try {

            PreparedStatement ptstmt = null;
            ResultSet         rs     = null;

            Connection con = getConnection();

            String sCountSQL = "select count(accountnumber) from accounts";
            sCountSQL = sCountSQL.toUpperCase();                                    
            int iAccounts = -1;
            
            //get number of rows (accounts)            
            ptstmt = con.prepareStatement(sCountSQL);
            rs = ptstmt.executeQuery();
            while (rs.next()) {
               iAccounts = rs.getInt(1);
            }//while

            
            if (iAccounts == 0) {
               sRowID = BankDatabaseConstants.sFirstAccountID;                 
            }//if                       
            else {//find biggest and increment by 1
                
               String sMAXSQL = "select max(accountnumber) from accounts";
               sMAXSQL = sMAXSQL.toUpperCase(); 
               int iCurrentMax = -1;
               int iNewMax = -1;
               
               //get max account number           
               ptstmt = con.prepareStatement(sMAXSQL);
               rs = ptstmt.executeQuery();
               while (rs.next()) {
                iCurrentMax = rs.getInt(1);
               }//while
                                
               iNewMax = (iCurrentMax + 1);
                                
               sRowID = new Integer(iNewMax).toString();             
                
            }//endif

            
            //create the new account for this customer
            //i.e.
            //insert into accounts values ('1000000', 1200.67,  'C', 300.00);

            String sInsertSQL = null;            
            sInsertSQL = "insert into accounts values (?, ?, ?, ?)";
            sInsertSQL = sInsertSQL.toUpperCase();            
            ptstmt = con.prepareStatement(sInsertSQL);
            
            input.setAccountNumber( sRowID );
            ptstmt.setString(1, input.getAccountNumber() );
            ptstmt.setDouble(2, input.getBalance().doubleValue() );
            ptstmt.setString(3, input.getType() );                                          
            ptstmt.setDouble(4, input.getMaximumDailyWithdrawalLimit().doubleValue() );
            ptstmt.executeUpdate();

            
            //insert row into customeraccounts table
            //i.e.
            //insert into customeraccounts values ('9999000000','1000000');

            sInsertSQL = "insert into customeraccounts values (?, ?)";
            sInsertSQL = sInsertSQL.toUpperCase();            
            ptstmt = con.prepareStatement(sInsertSQL);
            ptstmt.setString(1, c.getCustomerNumber() );
            ptstmt.setString(2, input.getAccountNumber() );
            ptstmt.executeUpdate();
            
            
            ptstmt.close();                     
            rs.close();
            closeConnection();
            
            input.setDescription( getAccountDescription( input.getType() ) );
            

        }//try
        catch(Exception e) {
        	throw e;        	
        }//catch
        
        
        return input;
        
    }

   
     public Account[] getAccounts(Customer c) throws Exception {
     	
     	String sCustomerNumber = null;
     	Account[] as = null;
        Vector accounts = new Vector();
                
        try {
            Connection con = getConnection();
            String sSQL      = "select customers.customernumber,accounts.accountnumber,accounts.balance,accounts.type, accounts.maxDailyWithdrawalLimit, accountdescriptions.description from customers,accounts,customeraccounts,accountdescriptions where (customers.customernumber=? AND customers.customernumber=customeraccounts.customernumber AND customeraccounts.accountnumber=accounts.accountnumber AND accounts.type=accountdescriptions.type) order by customers.customernumber,accounts.accountnumber,accountdescriptions.description";
            
            sCustomerNumber = c.getCustomerNumber();
            PreparedStatement stmt = con.prepareStatement(sSQL);
            stmt.setString(1, sCustomerNumber);
            
            ResultSet rs = stmt.executeQuery();
            Account a = null;
            
            while (rs.next()) {
            	a = new Account();
            	a.setAccountNumber(rs.getString("accountnumber"));
            	a.setBalance(new Double(rs.getDouble("balance")));
            	a.setType(rs.getString("type"));
            	a.setMaximumDailyWithdrawalLimit(new Double(rs.getDouble("maxDailyWithdrawalLimit")));
            	a.setDescription(rs.getString("description"));
            	accounts.add(a);
            }
            
            stmt.close();                     
            rs.close();

            closeConnection();
            
        } catch (Exception e) {
       		throw e;
        }
                
        if ( accounts.size() > 0) {
        	as = (Account[]) accounts.toArray(new Account[0]);
        }
        
        return as;
        
}

     public Account transfer(Account accountFrom,Account accountTo, Double amount) throws Exception {
     	
     	Account updatedAccountFrom = null;
     	
    	 try {
    	 	updatedAccountFrom = withdraw( accountFrom , amount );
    	 	deposit( accountTo, amount );
    	 }
    	 catch(Exception e){
    	     throw e;	
    	 }
    	 
    	 return updatedAccountFrom;
    }
     
     public Account deposit(Account input, Double amount) throws Exception {
     	
        try {
        	input = alterAccountBalance( input, amount );
        }
        catch(Exception e){
           throw e;	
        }
        
        return input;
     }
     
     
     public Account withdraw(Account input, Double amount) throws Exception {
     	
        try {
        	input = alterAccountBalance( input, new Double(amount.doubleValue() * -1) );
        }
        catch(Exception e){
           throw e;	
        }
        
        return input;
     }
     
     private Account alterAccountBalance(Account input, Double amountFactor) throws Exception {
     	
        try {

        	//get latest account data
            Account currentDBAccountState = new Account();
            currentDBAccountState.setAccountNumber( input.getAccountNumber() );
            currentDBAccountState = retrieveAccount( currentDBAccountState );
            
            //copy latest db data to the Account object
            input.setType( currentDBAccountState.getType() );
            input.setDescription( currentDBAccountState.getDescription() );            
            input.setMaximumDailyWithdrawalLimit( currentDBAccountState.getMaximumDailyWithdrawalLimit() );
            
            
            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;

	          //update the account's balance
	          //i.e.
	          // update accounts set balance = ? where accountnumber = ?
	          String sUpdateSQL = null;            
	          sUpdateSQL = "update accounts  set balance = ? where accountnumber = ?";
	          sUpdateSQL = sUpdateSQL.toUpperCase();            
	          
	          ptstmt = con.prepareStatement(sUpdateSQL);
	          
	          input.setBalance( new Double(currentDBAccountState.getBalance().doubleValue() + amountFactor.doubleValue() ) );
	          ptstmt.setDouble(1, input.getBalance().doubleValue() );
	          ptstmt.setString(2, input.getAccountNumber() );	          
	          ptstmt.executeUpdate();

            ptstmt.close();                     
            closeConnection();
            
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
         
        return input;

     }
     
     public boolean isWebLoginValid(String customerName, String password)  throws Exception {
     	//
     	// As long as the customerNumber exists in the database, we'll consider
     	// the login info valid.
     	
        boolean bRecordFound = false;     	
        try {

            Connection con = getConnection();
            
            PreparedStatement ptstmt = null;
            ResultSet rs = null;

            //retrieve the customer            
            	
            // select customernumber from customers where customernumber = ?
	        String sSelectSQL = null;            
	        sSelectSQL = "select customernumber from customers where customernumber = ?";
	        sSelectSQL = sSelectSQL.toUpperCase();            
	          
	        ptstmt = con.prepareStatement(sSelectSQL);
	        ptstmt.setString(1, customerName );
            	

	        rs = ptstmt.executeQuery();

	        while (rs.next()) {
	          //customer record was found
	          bRecordFound = true;
	        }//while

	        rs.close();
            ptstmt.close();                     
            closeConnection();
            
            
        }//try
        catch(Exception e) {
        	throw e;
        }//catch
        
     	return bRecordFound;
     }
     
}
