/*
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 

package com.emerged.news;

import java.util.Vector;

import com.emerged.news.NewsBean;
import com.ibm.websphere.sca.Ticket;
import commonj.sdo.DataObject;
import com.ibm.websphere.sca.ServiceManager;

public class NewsCategoriesMapImpl {
	com.ibm.websphere.sca.ServiceManager serviceManager = null;		
	com.ibm.websphere.bo.BOFactory boFactory = null;
	
	/**
	 * Default constructor.
	 */
	public NewsCategoriesMapImpl() {
		super();
		initialize();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This should be used when passing this service to another reference api
	 * or if you want to invoke yourself asynchonously.
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * This method is used to locate the service for the reference
	 * named "NewsBeanPartner".  This will return an instance of
	 * {@link NewsBean}.  If you would like to use this service 
	 * asynchronously then you will need to cast the result
	 * to {@link NewsBeanAsync}.
	 *
	 * @generated (com.ibm.wbit.java)
	 *
	 * @return NewsBean
	 */
	public NewsBean locateService_NewsBeanPartner() {
		return (NewsBean) ServiceManager.INSTANCE
				.locateService("NewsBeanPartner");
	}

	private void initialize() {
		try{
			serviceManager = new com.ibm.websphere.sca.ServiceManager();
			boFactory = (com.ibm.websphere.bo.BOFactory)serviceManager.locateService("com/ibm/websphere/bo/BOFactory");
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

	/**
	 * Method generated to support the implementing WSDL port type named "interface.NewsCategories".
	 */
	public DataObject getNewsCategories() {
		
		//get the NewsBean
		NewsBean nb = locateService_NewsBeanPartner();
		
		//get news categories
		NewsCategory[] newsCategories = nb.getNewsCategories();
		
		//convert NewCategory[] to sdo data object NewsCategoryList
		DataObject  categories = convertToSDONewsCategoryList(newsCategories);
		
		return categories;
	}

	private DataObject convertToSDONewsCategoryList(NewsCategory[] newsCategories) {
	    //create a NewsCategoryList sdo data object
		DataObject sdoObject = boFactory.create("http://eMergedLibrary/com/emerged/portal", "NewsCategoryListBO");
		Vector v = new Vector();
	    
	    if (newsCategories != null){

	      for(int i=0;i<newsCategories.length;i++){
	      	  //create a NewsCategory sdo data object and add it to the list
	  	      v.add( convertToSDONewsCategory(newsCategories[i]) );
	      }
	    }

	   //set the "value" property to contain a list of NewsCategory sdo objects
	   sdoObject.set("value",v);

	   return sdoObject;

	}
	
	private DataObject convertToSDONewsCategory(NewsCategory newsCategory) {
		DataObject sdoObject = null;
		
		if (newsCategory != null) {
			//create the NewsCategory sdo data object
			sdoObject = boFactory.create("http://eMergedLibrary/com/emerged/portal", "NewsCategoryBO");
			//set the "id" property
			sdoObject.setInt("id",newsCategory.getId());
			//set the "name" property
			sdoObject.setString("name",newsCategory.getName());
		}
		
		return sdoObject;
	}
	
	/**
	 * Method generated to support the async implementation using callback
	 * for the operation (@link com.emerged.news.NewsBean#getNewsArticles(DataObject aNewsCategory))
	 * of java interface (@link com.emerged.news.NewsBean)	
	 * @see com.emerged.news.NewsBean#getNewsArticles(DataObject aNewsCategory)	
	 */
	public void onGetNewsArticlesResponse(Ticket __ticket,
			DataObject returnValue, Exception exception) {
		//TODO Needs to be implemented.
	}

	/**
	 * Method generated to support the async implementation using callback
	 * for the operation (@link com.emerged.news.NewsBean#getNewsCategories())
	 * of java interface (@link com.emerged.news.NewsBean)	
	 * @see com.emerged.news.NewsBean#getNewsCategories()	
	 */
	public void onGetNewsCategoriesResponse(Ticket __ticket,
			DataObject returnValue, Exception exception) {
		//TODO Needs to be implemented.
	}

}