/*
 * Licensed Materials - Property of IBM
 * 
 * 		5724-I66
 * 
 * (C) Copyright IBM Corporation 2005. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 * 
 * DISCLAIMER:
 * The following [enclosed] code is sample code created by IBM
 * Corporation. This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications. The code is provided 'AS IS',
 * without warranty of any kind IBM shall not be liable for any damages
 * arising out of your use of sample code, even if they have been
 * advised of the possibility of such damages.
 */ 

package sca.component.java.impl;

import commonj.sdo.DataObject;
import com.ibm.websphere.sca.ServiceManager;

public class CreditCheckImpl {
	/**
	 * Default constructor.
	 */
	public CreditCheckImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * Method generated to support implemention of operation "checkCredit" defined for WSDL port type 
	 * named "interface.CreditCheckInterface".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that its a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public DataObject checkCredit(String taxpayerId) {
		DataObject creditBO = null;
		
		ServiceManager serviceManager;
		com.ibm.websphere.bo.BOFactory boFactory = null;
		
		try{
			serviceManager = new com.ibm.websphere.sca.ServiceManager();
			boFactory = (com.ibm.websphere.bo.BOFactory)serviceManager.locateService("com/ibm/websphere/bo/BOFactory");
		}
		catch(Exception e){
			e.printStackTrace();
		}

		if (boFactory != null) {
			//create the CreditBO sdo data object
			creditBO = boFactory.create("http://LoanApplicationModule/com/mybank/loan", "CreditBO");
		
			//set the "taxPayerId" property
			creditBO.setString("taxPayerId", taxpayerId);

			// Naturally, this would be looked up in a database of some form, but for demonstration
			// purposes, we are going to use hard-coded and random values
			
			//set the "name" property
			creditBO.setString("name", "John Smith");
		
			//make up a credit score
			java.util.Random r = new java.util.Random(new java.util.Date().getTime());
			
			creditBO.setDouble("creditScore", 500+r.nextDouble()*400);
		}
		
		return creditBO;
	}

}